Index: /branches/dev_001_GM/NEMO/OFF_SRC/IOM/iom.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OFF_SRC/IOM/iom.F90	(revision 950)
+++ /branches/dev_001_GM/NEMO/OFF_SRC/IOM/iom.F90	(revision 951)
@@ -6,4 +6,5 @@
    !! History :  9.0  ! 05 12  (J. Belier) Original code
    !!            9.0  ! 06 02  (S. Masson) Adaptation to NEMO
+   !!             "   ! 07 07  (D. Storkey) Changes to iom_gettime
    !!--------------------------------------------------------------------
    !!gm  caution add !DIR nec: improved performance to be checked as well as no result changes
@@ -19,4 +20,5 @@
    USE in_out_manager  ! I/O manager
    USE dom_oce         ! ocean space and time domain
+   USE lbclnk          ! lateal boundary condition / mpp exchanges
    USE iom_def         ! iom variables definitions
    USE iom_ioipsl      ! NetCDF format with IOIPSL library
@@ -28,4 +30,7 @@
    
    PUBLIC iom_open, iom_close, iom_varid, iom_get, iom_gettime, iom_rstput
+
+   PRIVATE iom_rp0d, iom_rp1d, iom_rp2d, iom_rp3d
+   PRIVATE iom_g0d, iom_g1d, iom_g2d, iom_g3d, iom_get_123d
 
    INTERFACE iom_get
@@ -38,5 +43,5 @@
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2006)
-   !! $Header$
+   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/IOM/iom.F90,v 1.10 2007/06/29 14:10:50 opalod Exp $
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -44,5 +49,5 @@
 CONTAINS
 
-   SUBROUTINE iom_open( cdname, kiomid, ldwrt, kdom, kiolib )
+   SUBROUTINE iom_open( cdname, kiomid, ldwrt, kdom, kiolib, ldstop )
       !!---------------------------------------------------------------------
       !!                   ***  SUBROUTINE  iom_open  ***
@@ -55,4 +60,5 @@
       INTEGER         , INTENT(in   ), OPTIONAL ::   kdom     ! Type of domain to be written (default = jpdom_local_noovlap)
       INTEGER         , INTENT(in   ), OPTIONAL ::   kiolib   ! library used to open the file (default = jpnf90) 
+      LOGICAL         , INTENT(in   ), OPTIONAL ::   ldstop   ! stop if open to read a non-existing file (default = .TRUE.)
 
       CHARACTER(LEN=100)    ::   clname    ! the name of the file based on cdname [[+clcpu]+clcpu]
@@ -62,5 +68,6 @@
       CHARACTER(LEN=100)    ::   clinfo    ! info character
       LOGICAL               ::   llok      ! check the existence 
-      LOGICAL               ::   llwrt     ! 
+      LOGICAL               ::   llwrt     ! local definition of ldwrt
+      LOGICAL               ::   llstop    ! local definition of ldstop
       INTEGER               ::   iolib     ! library do we use to open the file
       INTEGER               ::   icnt      ! counter for digits in clcpu (max = jpmax_digits)
@@ -89,4 +96,8 @@
       ELSE                        ;   llwrt = .FALSE.
       ENDIF
+      ! do we call ctl_stop if we try to open a non-existing file in read mode?
+      IF( PRESENT(ldstop) ) THEN   ;   llstop = ldstop
+      ELSE                         ;   llstop = .TRUE.
+      ENDIF
       ! what library do we use to open the file?
       IF( PRESENT(kiolib) ) THEN   ;   iolib = kiolib
@@ -110,6 +121,6 @@
       iln = LEN_TRIM(clname)
       ils = LEN_TRIM(clsuffix)
-      IF( iln <= ils) clname = clname(1:iln)//TRIM(clsuffix)
-      IF( clname(iln-ils+1:iln) /= TRIM(clsuffix) )   clname = clname(1:iln)//TRIM(clsuffix)
+      IF( iln <= ils .OR. INDEX( TRIM(clname), TRIM(clsuffix), back = .TRUE. ) /= iln - ils + 1 )   &
+         &   clname = TRIM(clname)//TRIM(clsuffix)
       cltmpn = clname   ! store this name
       ! try to find if the file to be opened already exist
@@ -118,7 +129,9 @@
       IF( .NOT.llok ) THEN
          ! we try to add the cpu number to the name
-         WRITE(clcpu,*) narea-1
+         IF( iolib == jprstdimg ) THEN   ;   WRITE(clcpu,*) narea
+         ELSE                            ;   WRITE(clcpu,*) narea-1
+         ENDIF
          clcpu  = TRIM(ADJUSTL(clcpu))
-         iln = INDEX(clname,TRIM(clsuffix))
+         iln = INDEX(clname,TRIM(clsuffix), back = .TRUE.)
          clname = clname(1:iln-1)//'_'//TRIM(clcpu)//TRIM(clsuffix)
          icnt = 0
@@ -132,38 +145,53 @@
          END DO
       ENDIF
-      ! check the domain definition
-      idom = jpdom_local_noovlap   ! default definition
-      IF( PRESENT(kdom) )   idom = kdom
-      ! create the domain informations
-      ! =============
-      SELECT CASE (idom)
-      CASE (jpdom_local_full)
-         idompar(:,1) = (/ jpi             , jpj              /)
-         idompar(:,2) = (/ nimpp           , njmpp            /)
-         idompar(:,3) = (/ nimpp + jpi - 1 , njmpp + jpj - 1  /)
-         idompar(:,4) = (/ nldi - 1        , nldj - 1         /)
-         idompar(:,5) = (/ jpi - nlei      , jpj - nlej       /)
-      CASE (jpdom_local_noextra)
-         idompar(:,1) = (/ nlci            , nlcj             /)
-         idompar(:,2) = (/ nimpp           , njmpp            /)
-         idompar(:,3) = (/ nimpp + nlci - 1, njmpp + nlcj - 1 /)
-         idompar(:,4) = (/ nldi - 1        , nldj - 1         /)
-         idompar(:,5) = (/ nlci - nlei     , nlcj - nlej      /)
-      CASE (jpdom_local_noovlap)
-         idompar(:,1) = (/ nlei - nldi + 1 , nlej - nldj + 1  /)
-         idompar(:,2) = (/ nimpp + nldi - 1, njmpp + nldj - 1 /)
-         idompar(:,3) = (/ nimpp + nlei - 1, njmpp + nlej - 1 /)
-         idompar(:,4) = (/ 0               , 0                /)
-         idompar(:,5) = (/ 0               , 0                /)
-      CASE DEFAULT
-         CALL ctl_stop( TRIM(clinfo), 'wrong value of kdom, only jpdom_local* cases are accepted' )
-      END SELECT
+      IF( llwrt ) THEN
+         ! check the domain definition
+! JMM + SM: ugly patch before getting the new version of lib_mpp)
+!         idom = jpdom_local_noovlap   ! default definition
+         IF( jpni*jpnj == jpnij ) THEN   ;   idom = jpdom_local_noovlap   ! default definition
+         ELSE                            ;   idom = jpdom_local_full      ! default definition
+         ENDIF
+         IF( PRESENT(kdom) )   idom = kdom
+         ! create the domain informations
+         ! =============
+         SELECT CASE (idom)
+         CASE (jpdom_local_full)
+            idompar(:,1) = (/ jpi             , jpj              /)
+            idompar(:,2) = (/ nimpp           , njmpp            /)
+            idompar(:,3) = (/ nimpp + jpi - 1 , njmpp + jpj - 1  /)
+            idompar(:,4) = (/ nldi - 1        , nldj - 1         /)
+            idompar(:,5) = (/ jpi - nlei      , jpj - nlej       /)
+         CASE (jpdom_local_noextra)
+            idompar(:,1) = (/ nlci            , nlcj             /)
+            idompar(:,2) = (/ nimpp           , njmpp            /)
+            idompar(:,3) = (/ nimpp + nlci - 1, njmpp + nlcj - 1 /)
+            idompar(:,4) = (/ nldi - 1        , nldj - 1         /)
+            idompar(:,5) = (/ nlci - nlei     , nlcj - nlej      /)
+         CASE (jpdom_local_noovlap)
+            idompar(:,1) = (/ nlei  - nldi + 1, nlej  - nldj + 1 /)
+            idompar(:,2) = (/ nimpp + nldi - 1, njmpp + nldj - 1 /)
+            idompar(:,3) = (/ nimpp + nlei - 1, njmpp + nlej - 1 /)
+            idompar(:,4) = (/ 0               , 0                /)
+            idompar(:,5) = (/ 0               , 0                /)
+         CASE DEFAULT
+            CALL ctl_stop( TRIM(clinfo), 'wrong value of kdom, only jpdom_local* cases are accepted' )
+         END SELECT
+      ENDIF
       ! Open the NetCDF or RSTDIMG file
       ! =============
       ! do we have some free file identifier?
       IF( MINVAL(iom_file(:)%nfid) /= 0 )   &
-            &   CALL ctl_stop( TRIM(clinfo), 'No more free file identifier', 'increase jpmax_files in iom_def' )
+         &   CALL ctl_stop( TRIM(clinfo), 'No more free file identifier', 'increase jpmax_files in iom_def' )
+      ! if no file was found...
+      IF( .NOT. llok ) THEN
+         IF( .NOT. llwrt ) THEN   ! we are in read mode 
+            IF( llstop ) THEN   ;   CALL ctl_stop( TRIM(clinfo), 'File '//TRIM(cltmpn)//'* not found' )
+            ELSE                ;   istop = nstop + 1   ! make sure that istop /= nstop so we don't open the file
+            ENDIF
+         ELSE                     ! we are in write mode so we 
+            clname = cltmpn       ! get back the file name without the cpu number
+         ENDIF
+      ENDIF
       IF( istop == nstop ) THEN   ! no error within this routine
-         IF( .NOT. llok )   clname = cltmpn   ! get back the file name without the cpu number
          SELECT CASE (iolib)
          CASE (jpioipsl )   ;   CALL iom_ioipsl_open(  clname, kiomid, llwrt, llok, idompar )
@@ -212,5 +240,5 @@
                END SELECT
                iom_file(jf)%nfid       = 0   ! free the id 
-               IF(lwp) WRITE(numout,*) TRIM(clinfo)//' close file: '//TRIM(iom_file(kiomid)%name)//' ok'
+               IF(lwp) WRITE(numout,*) TRIM(clinfo)//' close file: '//TRIM(iom_file(jf)%name)//' ok'
             ELSEIF( PRESENT(kiomid) ) THEN
                WRITE(ctmp1,*) '--->',  kiomid
@@ -223,5 +251,5 @@
 
 
-   FUNCTION iom_varid ( kiomid, cdvar, kdimsz )  
+   FUNCTION iom_varid ( kiomid, cdvar, kdimsz, ldstop )  
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  iom_varid  ***
@@ -232,13 +260,19 @@
       CHARACTER(len=*)     , INTENT(in   )           ::   cdvar    ! name of the variable
       INTEGER, DIMENSION(:), INTENT(  out), OPTIONAL ::   kdimsz   ! size of the dimensions
+      LOGICAL              , INTENT(in   ), OPTIONAL ::   ldstop   ! stop if looking for non-existing variable (default = .TRUE.)
       !
       INTEGER                        ::   iom_varid, iiv, i_nvd
       LOGICAL                        ::   ll_fnd
       CHARACTER(LEN=100)             ::   clinfo                   ! info character
+      LOGICAL                        ::   llstop                   ! local definition of ldstop
       !!-----------------------------------------------------------------------
-      clinfo = 'iom_varid, file: '//trim(iom_file(kiomid)%name)//', var: '//trim(cdvar)
       iom_varid = 0                         ! default definition
-      !
-      IF( kiomid > 0 ) THEN
+      ! do we call ctl_stop if we look for non-existing variable?
+      IF( PRESENT(ldstop) ) THEN   ;   llstop = ldstop
+      ELSE                         ;   llstop = .TRUE.
+      ENDIF
+      !
+      IF( kiomid > 0 ) THEN
+         clinfo = 'iom_varid, file: '//trim(iom_file(kiomid)%name)//', var: '//trim(cdvar)
          IF( iom_file(kiomid)%nfid == 0 ) THEN 
             CALL ctl_stop( trim(clinfo), 'the file is not open' )
@@ -257,6 +291,6 @@
                   SELECT CASE (iom_file(kiomid)%iolib)
                   CASE (jpioipsl )   ;   iom_varid = iom_ioipsl_varid( kiomid, cdvar, iiv, kdimsz )
-                  CASE (jpnf90   )   ;   iom_varid = iom_nf90_varid(   kiomid, cdvar, iiv, kdimsz )
-                  CASE (jprstdimg)   ;   iom_varid = 0   ! all variables are listed in iom_file
+                  CASE (jpnf90   )   ;   iom_varid = iom_nf90_varid  ( kiomid, cdvar, iiv, kdimsz )
+                  CASE (jprstdimg)   ;   iom_varid = -1   ! all variables are listed in iom_file
                   CASE DEFAULT   
                      CALL ctl_stop( TRIM(clinfo)//' accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
@@ -266,4 +300,5 @@
                         &                         'increase the parameter jpmax_vars')
                ENDIF
+               IF( llstop .AND. iom_varid == -1 )   CALL ctl_stop( TRIM(clinfo)//' not found' ) 
             ELSE
                iom_varid = iiv
@@ -294,14 +329,16 @@
       INTEGER               :: idvar   ! variable id
       !
-      idvar = iom_varid( kiomid, cdvar )
-      IF( iom_file(kiomid)%nfid > 0 .AND. idvar > 0 ) THEN
-         SELECT CASE (iom_file(kiomid)%iolib)
-         CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, pvar )
-         CASE (jpnf90   )   ;   CALL iom_nf90_get(    kiomid, idvar, pvar )
-         CASE (jprstdimg)   ;   CALL iom_rstdimg_get( kiomid, idvar, pvar )
-         CASE DEFAULT    
-            CALL ctl_stop( 'iom_g0d: accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
-         END SELECT
-      END IF
+      IF( kiomid > 0 ) THEN
+         idvar = iom_varid( kiomid, cdvar )
+         IF( iom_file(kiomid)%nfid > 0 .AND. idvar > 0 ) THEN
+            SELECT CASE (iom_file(kiomid)%iolib)
+            CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, pvar )
+            CASE (jpnf90   )   ;   CALL iom_nf90_get(    kiomid, idvar, pvar )
+            CASE (jprstdimg)   ;   CALL iom_rstdimg_get( kiomid, idvar, pvar )
+            CASE DEFAULT    
+               CALL ctl_stop( 'iom_g0d: accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
+            END SELECT
+         ENDIF
+      ENDIF
    END SUBROUTINE iom_g0d
 
@@ -315,6 +352,8 @@
       INTEGER         , INTENT(in   ), DIMENSION(1), OPTIONAL ::   kcount    ! number of points in each axis
       !
-      IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r1d=pvar,   &
-            &                                        ktime=ktime, kstart=kstart, kcount=kcount )
+      IF( kiomid > 0 ) THEN
+         IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r1d=pvar,   &
+              &                                                     ktime=ktime, kstart=kstart, kcount=kcount )
+      ENDIF
    END SUBROUTINE iom_g1d
 
@@ -328,6 +367,8 @@
       INTEGER         , INTENT(in   ), DIMENSION(2)  , OPTIONAL ::   kcount    ! number of points in each axis
       !
-      IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r2d=pvar,   &
-            &                                        ktime=ktime, kstart=kstart, kcount=kcount )
+      IF( kiomid > 0 ) THEN
+         IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r2d=pvar,   &
+              &                                                     ktime=ktime, kstart=kstart, kcount=kcount )
+      ENDIF
    END SUBROUTINE iom_g2d
 
@@ -341,12 +382,14 @@
       INTEGER         , INTENT(in   ), DIMENSION(3)    , OPTIONAL ::   kcount    ! number of points in each axis
       !
-      IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r3d=pvar,   &
-            &                                        ktime=ktime, kstart=kstart, kcount=kcount )
+      IF( kiomid > 0 ) THEN
+         IF( iom_file(kiomid)%nfid > 0 ) CALL iom_get_123d( kiomid, kdom       , cdvar        , pv_r3d=pvar,   &
+              &                                                     ktime=ktime, kstart=kstart, kcount=kcount )
+      ENDIF
    END SUBROUTINE iom_g3d
    !!----------------------------------------------------------------------
 
    SUBROUTINE iom_get_123d( kiomid, kdom  , cdvar ,   &
-         &                   pv_r1d, pv_r2d, pv_r3d,   &
-         &                   ktime , kstart, kcount  )
+         &                  pv_r1d, pv_r2d, pv_r3d,   &
+         &                  ktime , kstart, kcount  )
       !!-----------------------------------------------------------------------
       !!                  ***  ROUTINE  iom_get_123d  ***
@@ -373,22 +416,27 @@
       INTEGER                        ::   itime       ! record number
       INTEGER                        ::   istop       ! temporary value of nstop
+      INTEGER                        ::   ix1, ix2, iy1, iy2   ! subdomain indexes
+      INTEGER                        ::   ji, jj      ! loop counters
+      INTEGER                        ::   irankpv       ! 
+      INTEGER                        ::   ind1, ind2  ! substring index
       INTEGER, DIMENSION(jpmax_dims) ::   istart      ! starting point to read for each axis
       INTEGER, DIMENSION(jpmax_dims) ::   icnt        ! number of value to read along each axis 
       INTEGER, DIMENSION(jpmax_dims) ::   idimsz      ! size of the dimensions of the variable
+      INTEGER, DIMENSION(jpmax_dims) ::   ishape      ! size of the dimensions of the variable
       REAL(wp)                       ::   zscf, zofs  ! sacle_factor and add_offset
       INTEGER                        ::   itmp        ! temporary integer
       CHARACTER(LEN=100)             ::   clinfo      ! info character
+      CHARACTER(LEN=100)             ::   clname      ! file name
+      CHARACTER(LEN=1)               ::   clrankpv, cldmspc      ! 
       !---------------------------------------------------------------------
       !
-      clinfo = '          iom_get_123d, file: '//trim(iom_file(kiomid)%name)//', var: '//trim(cdvar)
+      clname = iom_file(kiomid)%name   !   esier to read
+      clinfo = '          iom_get_123d, file: '//trim(clname)//', var: '//trim(cdvar)
       ! local definition of the domain ?
       idom = kdom
       ! check kcount and kstart optionals parameters...
-      IF( PRESENT(kcount) .AND. (.NOT. PRESENT(kstart)) )   &
-            CALL ctl_stop( trim(clinfo), 'kcount present needs kstart present' )
-      IF( PRESENT(kstart) .AND. (.NOT. PRESENT(kcount)) )   &
-            CALL ctl_stop( trim(clinfo), 'kstart present needs kcount present' )
-      IF( PRESENT(kstart) .AND. idom /= jpdom_unknown   )   &
-            CALL ctl_stop( trim(clinfo), 'kstart present needs kdom = jpdom_unknown' )
+      IF( PRESENT(kcount) .AND. (.NOT. PRESENT(kstart)) ) CALL ctl_stop(trim(clinfo), 'kcount present needs kstart present')
+      IF( PRESENT(kstart) .AND. (.NOT. PRESENT(kcount)) ) CALL ctl_stop(trim(clinfo), 'kstart present needs kcount present')
+      IF( PRESENT(kstart) .AND. idom /= jpdom_unknown   ) CALL ctl_stop(trim(clinfo), 'kstart present needs kdom = jpdom_unknown')
 
       ! Search for the variable in the data base (eventually actualize data)
@@ -402,142 +450,86 @@
          idmspc = inbdim                                   ! number of spatial dimensions in the file
          IF( iom_file(kiomid)%luld(idvar) )   idmspc = inbdim - 1
-         IF( idmspc > 3 )   CALL ctl_stop(trim(clinfo),   &
-               &                    'the file has more than 3 spatial dimensions this case is not coded...' ) 
-         IF( idom == jpdom_local ) THEN        ! Identify the domain in case of jpdom_local definition
-            IF( idimsz(1) == jpi .AND. idimsz(2) == jpj ) THEN 
-               idom = jpdom_local_full
-            ELSEIF( idimsz(1) == nlci .AND. idimsz(2) == nlcj ) THEN 
-               idom = jpdom_local_noextra
-            ELSEIF( idimsz(1) == (nlei - nldi + 1) .AND. idimsz(2) == (nlej - nldj + 1) ) THEN 
-               idom = jpdom_local_noovlap
-            ELSE 
-               CALL ctl_stop( trim(clinfo), 'impossible to identify the local domain' )
-            ENDIF
-         ENDIF
+         IF( idmspc > 3 )   CALL ctl_stop(trim(clinfo), 'the file has more than 3 spatial dimensions this case is not coded...') 
+         !
+         ! update idom definition...
+         ! Identify the domain in case of jpdom_auto(glo/dta) definition
+         IF( idom == jpdom_autoglo .OR. idom == jpdom_autodta ) THEN            
+            IF( idom == jpdom_autoglo ) THEN   ;   idom = jpdom_global 
+            ELSE                               ;   idom = jpdom_data
+            ENDIF
+            ind1 = INDEX( clname, '_', back = .TRUE. ) + 1
+            ind2 = INDEX( clname, '.', back = .TRUE. ) - 1
+            IF( ind2 > ind1 ) THEN   ;   IF( VERIFY( clname(ind1:ind2), '0123456789' ) == 0 )   idom = jpdom_local   ;   ENDIF
+         ENDIF
+         ! Identify the domain in case of jpdom_local definition
+         IF( idom == jpdom_local ) THEN
+            IF(     idimsz(1) == jpi               .AND. idimsz(2) == jpj               ) THEN   ;   idom = jpdom_local_full
+            ELSEIF( idimsz(1) == nlci              .AND. idimsz(2) == nlcj              ) THEN   ;   idom = jpdom_local_noextra
+            ELSEIF( idimsz(1) == (nlei - nldi + 1) .AND. idimsz(2) == (nlej - nldj + 1) ) THEN   ;   idom = jpdom_local_noovlap
+            ELSE   ;   CALL ctl_stop( trim(clinfo), 'impossible to identify the local domain' )
+            ENDIF
+         ENDIF
+         !
+         ! check the consistency between input array and data rank in the file
+         !
+         ! initializations
+         itime = 1
+         IF( PRESENT(ktime) ) itime = ktime
+
+         irankpv = 1 * COUNT( (/PRESENT(pv_r1d)/) ) + 2 * COUNT( (/PRESENT(pv_r2d)/) ) + 3 * COUNT( (/PRESENT(pv_r3d)/) )
+         WRITE(clrankpv, fmt='(i1)') irankpv
+         WRITE(cldmspc , fmt='(i1)') idmspc
+         !
+         IF(     idmspc <  irankpv ) THEN 
+            CALL ctl_stop( TRIM(clinfo), 'The file has only '//cldmspc//' spatial dimension',   &
+               &                         'it is impossible to read a '//clrankpv//'D array from this file...' )
+         ELSEIF( idmspc == irankpv ) THEN
+            IF( PRESENT(pv_r1d) .AND. idom /= jpdom_unknown )   &
+               &   CALL ctl_stop( TRIM(clinfo), 'case not coded...You must use jpdom_unknown' )
+         ELSEIF( idmspc >  irankpv ) THEN
+               IF( PRESENT(pv_r2d) .AND. itime == 1 .AND. idimsz(3) == 1 .AND. idmspc == 3 ) THEN
+                  CALL ctl_warn( trim(clinfo), '2D array but 3 spatial dimensions for the data...'              ,   &
+                        &         'As the size of the z dimension is 1 and as we try to read the first record, ',   &
+                        &         'we accept this case, even if there is a possible mix-up between z and time dimension' )   
+                  idmspc = idmspc - 1
+               ELSE
+                  CALL ctl_stop( TRIM(clinfo), 'To keep iom lisibility, when reading a '//clrankpv//'D array,'         ,   &
+                     &                         'we do not accept data with more than '//cldmspc//' spatial dimension',   &
+                     &                         'Use ncwa -a to suppress the unnecessary dimensions' )
+               ENDIF
+         ENDIF
+
          !
          ! definition of istart and icnt
          !
-         ! initializations
+         icnt  (:) = 1
          istart(:) = 1
-         icnt  (:) = 1
-         itime = 1
-         IF( PRESENT(ktime) ) itime = ktime
-         !
-         IF( PRESENT(pv_r1d) ) THEN
-            IF( idmspc == 1 ) THEN 
-               ! data is 1d array (+ maybe a temporal dimension)
-               IF( PRESENT(kstart) ) THEN
-                  istart(1:2) = (/ kstart(1), itime /)
-                  icnt(1) = kcount(1)
-               ELSE
-                  IF( kdom == jpdom_unknown ) THEN
-                     istart(2) = itime
-                     icnt(1) = idimsz(1)
-                  ELSE 
-                     CALL ctl_stop( trim(clinfo), 'case not coded...You must use jpdom_unknown' )
+         istart(idmspc+1) = itime
+
+         IF(              PRESENT(kstart)       ) THEN ; istart(1:idmspc) = kstart(1:idmspc) ; icnt(1:idmspc) = kcount(1:idmspc)
+         ELSE
+            IF(           idom == jpdom_unknown ) THEN                                       ; icnt(1:idmspc) = idimsz(1:idmspc)
+            ELSE 
+               IF( .NOT. PRESENT(pv_r1d) ) THEN   !   not a 1D array
+                  IF(     idom == jpdom_data    ) THEN ; istart(1:2) = (/ mig(1), mjg(1) /)  ! icnt(1:2) done bellow
+                  ELSEIF( idom == jpdom_global  ) THEN ; istart(1:2) = (/ nimpp , njmpp  /)  ! icnt(1:2) done bellow
                   ENDIF
-               ENDIF
-            ELSE
-               CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 1D array,', &
-                     &         'we do not accept data with more than 1 spatial dimension',     &
-                     &         'Use ncwa -a to suppress the unnecessary dimensions')
-            ENDIF
-         ELSEIF( PRESENT(pv_r2d) ) THEN
-            SELECT CASE (idmspc)
-            CASE (1)
-               CALL ctl_stop( trim(clinfo), 'the file has only 1 spatial dimension',  &
-                     &         'it is impossible to read a 2d array from this file...')
-            CASE (2)
-               ! data is 2d array (+ maybe a temporal dimension)
-               IF( PRESENT(kstart) ) THEN
-                  istart(1:3) = (/ kstart(1:2), itime /)
-                  icnt(1:2) = kcount(1:2)
-               ELSE
-                  IF( kdom == jpdom_unknown ) THEN
-                     istart(3) = itime
-                     icnt(1:2) = idimsz(1:2)
-                  ELSE 
-                     IF( idom == jpdom_data ) THEN
-                        istart(1:3) = (/ mig(1), mjg(1), itime /)
-                     ELSEIF( idom == jpdom_global ) THEN
-                        istart(1:3) = (/ nimpp, njmpp, itime /)
-                     ENDIF
-                     ! we do not read the overlap -> we start to read at nldi, nldj
-                     IF( idom /= jpdom_local_noovlap )   istart(1:2) = istart(1:2) + (/ nldi - 1, nldj - 1 /)
-                     ! we do not read the overlap and the extra-halos  
-                     ! -> from nldi to nlei and from nldj to nlej 
-                     icnt(1:2) = (/ nlei - nldi + 1, nlej - nldj + 1 /)
+                  ! we do not read the overlap                     -> we start to read at nldi, nldj
+! JMM + SM: ugly patch before getting the new version of lib_mpp)
+!                  IF( idom /= jpdom_local_noovlap )   istart(1:2) = istart(1:2) + (/ nldi - 1, nldj - 1 /)
+                  IF( jpni*jpnj == jpnij .AND. idom /= jpdom_local_noovlap ) istart(1:2) = istart(1:2) + (/ nldi - 1, nldj - 1 /)
+                  ! we do not read the overlap and the extra-halos -> from nldi to nlei and from nldj to nlej 
+! JMM + SM: ugly patch before getting the new version of lib_mpp)
+!                  icnt(1:2) = (/ nlei - nldi + 1, nlej - nldj + 1 /)
+                  IF( jpni*jpnj == jpnij ) THEN   ;   icnt(1:2) = (/ nlei - nldi + 1, nlej - nldj + 1 /)
+                  ELSE                            ;   icnt(1:2) = (/ nlci           , nlcj            /)
                   ENDIF
-               ENDIF
-            CASE DEFAULT
-               IF( itime == 1 .AND. idimsz(3) == 1 .AND. idmspc == 3 ) THEN
-                  CALL ctl_warn( trim(clinfo), '2D array but 3 spatial dimensions for the data...',                &
-                        &         'As the size of the z dimension is 1 and as we try to read the first record, ',   &
-                        &         'we accept this case even if there is a possible mix-up between z and time dimension' )           
-                  IF( PRESENT(kstart) ) THEN
-                     istart(1:2) = kstart(1:2)
-                     icnt(1:2) = kcount(1:2)
-                  ELSE
-                     IF( kdom == jpdom_unknown ) THEN
-                        icnt(1:2) = idimsz(1:2)
-                     ELSE 
-                        IF( idom == jpdom_data ) THEN
-                           istart(1:2) = (/ mig(1), mjg(1) /)
-                        ELSEIF( idom == jpdom_global ) THEN
-                           istart(1:2) = (/ nimpp, njmpp /)
-                        ENDIF
-                        ! we do not read the overlap -> we start to read at nldi, nldj
-                        IF( idom /= jpdom_local_noovlap )   istart(1:2) = istart(1:2) + (/ nldi - 1, nldj - 1 /)
-                        ! we do not read the overlap and the extra-halos  
-                        ! -> from nldi to nlei and from nldj to nlej 
-                        icnt(1:2) = (/ nlei - nldi + 1, nlej - nldj + 1 /)
-                     ENDIF
-                  ENDIF
-               ELSE
-                  CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 2D array,',           &
-                        &                       'we do not accept data with more than 2 spatial dimension',   &
-                        &                       'Use ncwa -a to suppress the unnecessary dimensions' )
-               ENDIF
-            END SELECT
-         ELSEIF( PRESENT(pv_r3d) ) THEN
-            SELECT CASE (idmspc)
-            CASE( 1 )
-               CALL ctl_stop( trim(clinfo), 'the file has only 1 spatial dimension',            &
-                     &                       'it is impossible to read a 3d array from this file...' )
-            CASE( 2 )
-               CALL ctl_stop( trim(clinfo), 'the file has only 2 spatial dimension',            &
-                     &                       'it is impossible to read a 3d array from this file...' )
-            CASE( 3 )
-               ! data is 3d array (+ maybe a temporal dimension)
-               IF( PRESENT(kstart) ) THEN
-                  istart(1:4) = (/ kstart(1:3), itime /)
-                  icnt(1:3) = kcount(1:3)
-               ELSE
-                  IF( kdom == jpdom_unknown ) THEN
-                     istart(4) = itime
-                     icnt(1:3) = idimsz(1:3)
-                  ELSE 
-                     IF( idom == jpdom_data ) THEN
-                        istart(1:4) = (/ mig(1), mjg(1), 1, itime /)
-                     ELSEIF( idom == jpdom_global ) THEN
-                        istart(1:4) = (/ nimpp, njmpp, 1, itime /)
-                     ENDIF
-                     ! we do not read the overlap -> we start to read at nldi, nldj
-                     IF( idom /= jpdom_local_noovlap )   istart(1:2) = istart(1:2) + (/ nldi - 1, nldj - 1 /)
-                     ! we do not read the overlap and the extra-halos
-                     ! -> from nldi to nlei and from nldj to nlej 
-                     icnt(1:2) = (/ nlei - nldi + 1, nlej - nldj + 1 /)
-                     IF( idom == jpdom_data ) THEN 
-                        icnt(3) = jpkdta
-                     ELSE
-                        icnt(3) = jpk
+                  IF( PRESENT(pv_r3d) ) THEN
+                     IF( idom == jpdom_data ) THEN   ; icnt(3) = jpkdta
+                     ELSE                            ; icnt(3) = jpk
                      ENDIF
                   ENDIF
                ENDIF
-            CASE DEFAULT
-               CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 3D array,',   &
-                     &         'we do not accept data with more than 3 spatial dimension',         &
-                     &         'Use ncwa -a to suppress the unnecessary dimensions' )           
-            END SELECT
+            ENDIF
          ENDIF
 
@@ -546,7 +538,7 @@
          DO jl = 1, jpmax_dims
             itmp = istart(jl)+icnt(jl)-1
-            IF( (itmp) > idimsz(jl) .AND. idimsz(jl) /= 0 ) THEN
-               WRITE(ctmp1,*) '(istart(',jl,') + icnt(',jl,') - 1) = ', itmp
-               WRITE(ctmp2,*) ' is larger than idimsz(',jl,'): ', idimsz(jl)
+            IF( itmp > idimsz(jl) .AND. idimsz(jl) /= 0 ) THEN
+               WRITE( ctmp1, FMT="('(istart(', i1, ') + icnt(', i1, ') - 1) = ', i5)" ) jl, jl, itmp
+               WRITE( ctmp2, FMT="(' is larger than idimsz(', i1,') = ', i5)"         ) jl, idimsz(jl)
                CALL ctl_stop( trim(clinfo), 'start and count too big regarding to the size of the data, ', ctmp1, ctmp2 )     
             ENDIF
